unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    PanelBase: TPanel;
    Panel1: TPanel;
    Image1: TImage;
    ScrollBar1: TScrollBar;
    procedure FormCreate(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  R : TRect;
  Captura : Boolean;
  PuntoCaptura : TPoint;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var a:Integer;
begin
  Panel1.Width:=36000;
  Image1.Width:=36000;
  a:=0;
  with Image1.Canvas do
  begin
    //Dibuja el fondo de la imagen
    Brush.Color:=ClCream;
    R.Left:=0;
    R.Top:=0;
    R.Right:=36000;
    R.Bottom:=172;
    FillRect(R);
    //Dibuja los bordes de la imagen
    MoveTo(0,0);
    LineTo(36000,0);
    LineTo(36000,171);
    LineTo(0,171);
    LineTo(0,0);
    MoveTo(0,13);
    LineTo(36000,13);
    //Dibuja las lneas verticales
    repeat
      Inc(a,10);
      MoveTo(a,13);LineTo(a,172);
    until a=36000;
    //Dibuja los nmeros de pixeles
    Brush.Style:=bsClear;
    Font.Color:=ClBlack;
    Font.Name:='Ms Sans Serif';
    Font.Size:=8;
    Font.Pitch:=FpFixed;
    for a:=0 to 36000 do
    TextOut((a*50)-10,1,IntToStr(a*50));
  end;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  //Captura la imagen y cambia el puntero
  if (Button=mbLeft) and (Y>23) then
  begin
    Captura:=True;
    PuntoCaptura.X:=X;PuntoCaptura.Y:=Y;
    Screen.Cursor:=crSizeWE;
  end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var Posicion:Integer;
begin
  //Mueve la imagen y su panel contenedor entre los lmites
  if Captura=True then
  begin
    Posicion:=Panel1.Left-(PuntoCaptura.x-x);
    if Posicion>0 then Posicion:=0 else
    if Posicion<PanelBase.Width-36000 then Posicion:=PanelBase.Width-36000;
    Panel1.Left:=Posicion;
  end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  //Libera la captura de la imagen y vuelve a cambiar el cursor
  if Button=mbLeft then
  begin
    Captura:=False;
    Screen.Cursor:=crDefault;
  end;
end;

procedure TForm1.ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  Panel1.Left:=-Scrollbar1.Position;
end;

end.
